;*******************************************************************************
;				WH1602_ATMega8_enc_v6.1.asm
;	 FM-   RDA5807M  LCD- WH1602
;  ATMEGA8    .  8 .
; 		  :
;-*-    .
;-*-          
;         .
;-*-         
;         .
;-*-         
;-*-       .
;-*-        .
;-*-       .
;-*-       EEPROM.
;-*-       .
;-*-       .
;-*-    "-" .
;-*-         .
;
;	  :
; PB0 -     .
;
; PD0 - D7 -    WH1602A
; PD1 - D6 -    WH1602A
; PD2 - D5 -    WH1602A
; PD3 - D4 -    WH1602A
; PD4 - E  -   WH1602A
; PD5 - RS -   WH1602A
; PD6 -
; PD7 - .   -
;
; PC0 -    
; PC1 -    
; PC2 -  
; PC3 - 
; PC4 - (SDA) -    I2C
; PC5 - (SCL) -    I2C
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
    #define F_CPU (8000000) ; 
	
  	;   
  	.def Tseek = R4			;   
  	.def R_mode = R8		;c  .  0:  preset=0/auto=1
    .def cntrl	= R13    	;  
  		.equ ENC = 0			;  
  		.equ SEK = 1			;  
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def time  = r21		;  
	.def F_3H  = r22		;.   
	.def F_3L  = r23		;.   
	.def freq  = r24		;   ( )
	
	.equ Tm_l  = 30			;  
;===============================================================================
	.DSEG					;    SRAM ()
	.ORG 0x060				;   
	decnum:		.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	
;=============================================================================
	.ESEG				;    EEPROM
	 Fst_EE:	.BYTE 1 		;   ( )
	 Vol_EE:	.BYTE 1 		; 
;=============================================================================
;-------------------------  -------------------------------------------
	
	.MACRO LOAD_ADDR 		 		;   16- 
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO						;
	
	.MACRO 	PAUSA					; 1  = 5 
		ldi temp,@0					;  
		rcall pause					; / 
	.ENDMACRO						;
	
;=============================================================================
	.CSEG		;  
	.ORG 0 		; 
	rjmp RESET			;Reset
	reti				;  INT 0
	reti				;  INT 1
	reti				; / 2  
	reti				; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	rjmp OVF_T1			; / 1  
	reti				; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:		;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B
		ldi temp,0b00000001			;
		out DDRB,temp   			;  
		ldi temp,0b11111110			;
		out PORTB,temp   			;  
			;  ,  .    
	 	ldi temp,0b00000000			;      
		out DDRC,temp   			;
		ldi temp,0b11110111			;
		out PORTC,temp   			;  
		
			;  D,  .  LCD-
	 	ldi temp,0b11111111			;   D  
		out DDRD,temp				;
		ldi temp,0					;
		out PORTD,temp				;   D  
		
			; 
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		ldi temp,(1<<TOIE1)|(1<<TOIE0)		;. .  1  0
		out TIMSK,temp						;
	;	ldi temp,(1<<CS01)|(1<<CS00)		;  0   1/32
		ldi temp,(1<<CS02)					;  0   1/64
	;	ldi temp,(1<<CS02)|(1<<CS00)		;  0   1/128
		out TCCR0,temp						;
		
		sei                         ;  
		
;===================   ==================================
		rcall light					;  
		; LCD 
		rcall lcd_init				; LCD 
		ldi r16,0x0					;    
		rcall LCD_SetAddressDD		;    LCD 
		;    
		LOAD_ADDR Z,Mesg_1*2		;.  Z  . "  FM-    MHz "
		rcall LCD_WriteString		;   
		;   
		ldi r16,0x1					;   LCD
		rcall LCD_SetAddressDD		;    LCD 
		ldi r16,2					;  0
		rcall LCD_WriteData			;   LCD
		ldi r16,2					;  0
		rcall LCD_WriteData			;   LCD
;------------------------------------------------------------------------------
		;  RDA5807
		rcall IIC_init				;  I2C
		PAUSA 80					; 400 
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		ldi temp,15					; 
		sts volume,temp				;   = 15
		rcall Rd_St					;   EEPROM
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		PAUSA 20					; 100 
		;      
		rcall Prnt_F				;   
		rcall rekog					;/  
		;    
		rcall ch_st					; RDA5807
		PAUSA 20					; 100 
		; 
		clr R2						;  
		clr R6						;  
		clr R8						;   
		clr R10						;  
		clr R11						;   
		clr cntrl					;  . 
		clr freq					;  
		clr temp3					;  R19
		
;===============   ============================================
main: 	sbrc cntrl,ENC				;  , -
		rjmp mn_upr					;    ,
		sbrc cntrl,SEK				;   , -
		rcall ch_seek				;   
		clr cntrl					;   
 mn_upr:	;  
		tst R2						;    ,
		brne mn_key					;    . 
		sbic PINC,PC2				;     
		rjmp rotare					;   
		;   ()
		in temp,PINC				;  
		com temp					; 
		andi temp,0x04				;  
		mov R1,temp					;  R1
 mn_key:	;   
		PAUSA 7						; 35 
		inc R11						;   
		ldi temp,40					;  
		cp R11,temp					;  , 
		brsh mode_s					;   .  , -
		in temp,PINC				;  
		com temp					; 
		andi temp,0x04				;  
		cp temp,R1					;  , 
		brne key_comand				;      -
		mov R2,R1					;    
		rjmp main					;   
key_comand:		;  
		ldi temp,40					;  
		cp R11,temp					;  , 
		brsh mode_s					;   .  , -
		rcall li_upr				;  
		rjmp m_loop					;    
		
 rotare:		; 
		rcall Encoder				;  
		tst R1						;  ,
		brne m_enc					;    
		rcall del_enc				; 0,1 
	;	rjmp main					; ,  

		sbrc cntrl,ENC				;  , -
		rjmp main					;  
		rjmp mn_slp					; , 
		
		
m_enc:		;  
		rcall light					;  
		sbrs R8,0					;   , -
		rjmp hand					;    
			;
avto:	sbrc R10,0					;   . .
		rcall freq_Up				;    
		sbrc R10,1					;   . .
		rcall freq_Down				;    
		rjmp m_loop					;
			;  
hand:	sbrc R10,0					;   . .
		rcall Num_Up				;     
		sbrc R10,1					;   . .
		rcall Num_Down				;     
		
m_loop: clr R1						;  
		clr R2						;  
		clr R10						;  
		clr R11						;  .  
		
		sbrc cntrl,ENC				;  , -
		rjmp main					;  
		
 mn_slp:		;    
		ldi temp,(1<<SE)					;. Idle -  0  1
	;	ldi temp,(1<<SE)|(1<<SM0)			;. ADCNR -  , T2  .
	;	ldi temp,(1<<SE)|(1<<SM1)			;. Power Down -  INT1, INT0, TWI
	;	ldi temp,(1<<SE)|((1<<SM1)|(1<<SM0)	;. Power Save -  INT1, INT0, TWI
		out MCUCR,temp						;   
		sleep								; 
		
		clr temp					;
		out MCUCR,temp				;  
		rjmp main					;   
		
;===========================================================================
;	   /
; .  R8  0:  preset=0/auto=1
;---------------------------------------------------------------------------
mode_s:	rcall light					;  
		sbrs R8,0					;   ,
		rjmp md_auto				;     ,
		ldi temp,0b11111110			;  -
		and R8,temp					;   
		
			;  "Preset"
		ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg6*2		;.  Z   "Preset"
		rcall LCD_WriteString		;   
		rjmp rev_end				;    /
		
md_auto:	;  
		ldi temp,0b00000001			;  -
		or R8,temp					;   
		
		;  "Autotune"
		ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg5*2		;.  Z   "Autotune"
		rcall LCD_WriteString		;   
		
rev_end:		;   
	 	PAUSA 20					; 100 
 		in temp,PINC				;  
		com temp					; 
		andi temp,0x04				;  
 		tst temp					;   
		brne rev_end				;   
		PAUSA 100					; 500 
		clr R6						;  
		
		rjmp m_loop					;   
 	;	ret
;===========================================================================
;	  
;---------------------------------------------------------------------------
Encoder:
		clr R1						;  
		in temp,PINC				;  
		mov  temp1,temp				;
		andi temp1,0b00000011		;  
		cpi temp1,1					;   1, 
		breq enc_1					;   R10=1
		cpi temp1,2					;   2, 
		breq enc_2					;   R10=2
		tst temp1					;   
		breq enc_3					;  
		rjmp enc_out				;
		;
enc_1:	ldi temp1,1					;
		mov R10,temp1				; R10=1
		rjmp enc_out				;
enc_2:	ldi temp1,2					;
		mov R10,temp1				; R10=2
		rjmp enc_out				;
enc_3:	mov R1,R10					;   
		rcall del_enc				; 0,1 
		
enc_out:	ret
		
;=============================================================================
; 	     0,1 
;-----------------------------------------------------------------------------
del_enc:	push r16		;
			ldi r16,230		;  
			dec r16			; 
			brne PC-1		;  
			pop r16			;
			ret
;===========================================================================
 Num_Up:			;   
 		clr R1						;
 		inc R9						;  
		mov temp,R9					;
 		cpi temp,Nst				;    > Nst
 		brmi PC+2					;
 		clr  R9						;    0
		rcall Name_prnt				;    LCD 
		PAUSA 60					; 300 
		
		ldi temp,2					;  
		mov Tseek,temp				;
		ldi temp,0b00000011			;
		out TCCR1B,temp				;  1   1/64
		clr temp					;
		sbr temp,(1<<ENC)+(0<<SEK)	;   
		mov cntrl,temp				;
		
 		clr temp					;
 		ret
 		
 ;===========================================================================
 Num_Down:			;   
 		clr R1						;  
		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl um_nom					;   ,  -
 		ldi temp,Nst-1				;
 		mov R9,temp					;
 um_nom:
 		rcall Name_prnt				;    LCD 
 		PAUSA 60					; 300 
		
		ldi temp,2					;  
		mov Tseek,temp				;
		ldi temp,0b00000011			;
		out TCCR1B,temp				;  1   1/64
		clr temp					;
		sbr temp,(1<<ENC)+(0<<SEK)	;   
		mov cntrl,temp				;
		
		clr temp					;
 		ret
 		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
Name_prnt:
		ldi r16,0x40				;     
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
		
		ldi temp,18					;  
		mul temp,R9        			;     
		add ZL,R0					;  .  
		adc ZH,R1					;
		
		adiw Z,1					;    
		rcall LCD_WriteString		;    
		
		ret
		
;===========================================================================
freq_Up:	;   "+"   
		cli							; 
		clr R1						;  
		inc freq					; 
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
			;  "Autotune"
		ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg5*2		;.  Z   "Autotune"
		rcall LCD_WriteString		;   
		cbi PORTD,7					;  
			;     
		ldi temp,0b10010011			;(02H) ., DMUTE=0,,,
									; SEEKUP=1, SEEK=1 ( )
		mov r5,temp					; - 
r_con:	rcall Config_RDA5807		; 
		
nov_p:	PAUSA 100					; 500 
		rcall Read_RDA5807			;   RDA5807
		PAUSA 30					; 150 
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		PAUSA 30					; 150 
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  
		clr temp					; temp    
		sei
 		ret
;===========================================================================
freq_Down:		;   "-"   
		cli							; 
		clr R1						;  
		dec freq					; 
			;  "Autotune"
nastr:	ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		LOAD_ADDR Z,Messg5*2		;.  Z   "Autotune"
		rcall LCD_WriteString		;   
		cbi PORTD,7					;  
			;     
		ldi temp,0b10010001			;(02H) ., DMUTE=0,,,
									; SEEKUP=0, SEEK=1 ( )
		mov r5,temp					; - 
rm_con:	rcall Config_RDA5807		; 
		
nov_m:	PAUSA 100					; 500 
		rcall Read_RDA5807			;   RDA5807
		PAUSA 30					; 150 
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		PAUSA 30					; 150 
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					;
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									; SEEKUP=1, SEEK=0 ( )
		mov r5,temp					; - 
		rcall Config_RDA5807		; 
		
		sbrc r17,2					; , -
		sbi PORTD,7					;   
		rcall type_lev				;  
		rcall Prnt_F				;   
		rcall rekog					; 
		
		clr temp					; temp    
 		sei
 		ret
;===========================================================================
;	/     
;---------------------------------------------------------------------------

 ch_seek:		;     . 
 		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
 		tst R9						;
 		breq st_set					;  =0,   
 		push R9						;
		adiw Z,18					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Prnt_F				;   
		rcall Prn_Ch				;   
		;   
ch_st:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									;SEEKUP=1, SEEK=0 ( )
		mov r5,temp					;
		rcall Config_RDA5807		;  /
		
		cbi PORTD,7					;  
		PAUSA 100					; 500 
		rcall Read_RDA5807			;   RDA5807
		PAUSA 30					; 150 
		
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		sbi PORTD,7					;   
		rcall type_lev				;  
		
		clr temp					; temp    
		sei
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:	cli							;
		clr R9						;  
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  , 
		cpi temp,Nst				;    , -
		brsh fall					;  . ". "
		adiw Z,18					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Mesg_2*2		;  . ". "
		rjmp PC+2					;
		
na_ind:	adiw Z,1					;    
			;    
Prn_Ch:	ldi r16,0x40				;    
		rcall LCD_SetAddressDD		;    LCD 
		rcall LCD_WriteString		;    
		sei
		
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		cli
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		sei
		
		ret
		
;===========================================================================
;	 /    , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	
		cli
		LOAD_ADDR Y,Fst_EE			;.  Y . .. 
		clr freq					;
Rd_EEF:	sbic EECR,EEWE				;   
		rjmp Rd_EEF					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		
		sei
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		cli
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0					;(04H)
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b11000000			; .   
		rcall IIC_Send				;  
		
		rcall iic_stop 				; 
		rcall Wr_EEF				;    
		
		pop R16          		;   SREG
    	out SREG,R16     		;
    	pop R16          		;   R16
		sei
		ret
;===========================================================================
;		    ,  YH:YL   
;---------------------------------------------------------------------------
Wr_EEF:	
		cli
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei
		
		ret

;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:
		cli
		;    LCD
		ldi r16,0x1					;   LCD
		rcall LCD_SetAddressDD		;    LCD 
		
		lds temp,level				;     
		
		cpi temp,100					; 4- 
		brmi PC+6					;
		
		; 4-  
		ldi r16,4					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,6					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		cpi temp,50					; 3- 
		brmi PC+6					;
		
		; 3-  
		ldi r16,4					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,5					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+6					;
		
		; 2-  
		ldi r16,4					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+6					;
		
		; 1-  
		ldi r16,3					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		rjmp tp_lev					;    /
		
		; 0-  
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		ldi r16,2					; 
		rcall LCD_WriteData			;   LCD
		
tp_lev:	sei
		ret

;===========================================================================
;	  
;---------------------------------------------------------------------------
 light:	ldi temp,Tm_l				; 
		mov R12,temp				;  
		sbi PORTB,PB0				; 
		clr temp					;
		ldi temp,(1<<CS11)|(1<<CS10)		;
		out TCCR1B,temp				;  1   1/64
		ret
;===========================================================================
;		 / 
;---------------------------------------------------------------------------
 li_upr:	sbic PORTB,PB0				;  , -
 			rjmp li_out					;
 			
			sbi PORTB,PB0				; 
			clr R6						;
			inc R6						;  . .
			rjmp PC+4					;
			
li_out:		cbi PORTB,PB0				; 
			clr R6						;  . .
			PAUSA 150					; 750 
			ret
			
;===========================================================================
; /     1
;---------------------------------------------------------------------------
OVF_T1:	
		push R19          	;   R19
    	in R19,SREG      	;
   		push R19         	;   SREG
		
		;    
		tst Tseek			;
		breq dly_lgh		;
		dec Tseek			;    , -
		brne dly_lgh		;   /,  -
		
		sbrs cntrl,ENC		;  , -
		rjmp T1_off			;    ,
		
		clr R19				;
		sbr R19,(1<<SEK)	; . 
		cbr R19,(1<<ENC)	;    
		mov cntrl,R19		;
		
dly_lgh:	;  
		tst R12				;   , -
		breq T1_off			;
		dec R12				; 
		brne T1_ex			;   /,  -
		
		tst R6				; . , -
		brne T1_off			;   
		cbi PORTB,PB0		; 
		
T1_off:	ldi R19,0			;  1
		out TCCR1B,R19		;
		;
		
T1_ex:	pop R19          	;   SREG
    	out SREG,R19     	;
    	pop R19          	;   R19
		
		reti
		
;===========================================================================
;		 .
;	 . temp     5 ,  temp1=53
;	 . temp     10 ,  temp1=106
;---------------------------------------------------------------------------
pause:	cli
		push temp1					;
		push temp2					;
		in temp2,SREG     		 	;
		push temp2					;   SREG
		
 paus1:	ldi temp1,53				; . 
		ldi temp2,251				; . 
		dec temp2					;
		brne PC-1					;
		dec temp1					;
		brne PC-4					;
		dec temp					;   5 
		brne paus1					; 
		
		pop temp2          			;
    	out SREG,temp2     			;   SREG
		pop temp2					;
		pop temp1					;
		
		sei
		ret							;
		
;===========================================================================
;		      LCD 
;---------------------------------------------------------------------------
Prnt_F:	
		cli
		;    LCD
		ldi r16,0x7					;   LCD
		rcall LCD_SetAddressDD		;    LCD 
		;    
		clr r18						;
		ldi r17,HIGH(870)			;  
		ldi temp,LOW(870)			; : 870  
		add temp,freq				;   
		adc r17,r18					;
		;   10- 
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum+3)			;.  X . .   
		clr YH						;
		;  
		ld r16,Y					; .  
		tst r16						;    0,  -
		brne PC+4					;    
		ldi r16,0x20				;
		rcall LCD_WriteData			;  LCD 
		rjmp PC+2
		rcall LCD_WriteHexDigit		;  LCD  
		ld r16,-Y					;
		rcall LCD_WriteHexDigit		;  LCD  
		ld r16,-Y					;
		rcall LCD_WriteHexDigit		;  LCD  
		ldI r16,0x2C				;
		rcall LCD_WriteData			;  LCD 
		ld r16,-Y					;
		rcall LCD_WriteHexDigit		;  LCD   
		
		ret
		
;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	cli
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     sei
     ret
	
;===================================================================================
			;     
  Mesg_1: .DB  7,' ',' ',' ','F','M','-',' ',' ',' ',' ',' ',' ','M','H','z', 0, 0
  Mesg_2: .DB  'U','n','k','n','o','w',' ','c','h','a','n','n','e','l',' ',' ', 0, 0
  Mesg_3: .DB  ' ',' ',' ',' ','F','M','-',' ',' ',' ',' ',' ',' ',' ',' ',' ', 0, 0
  Messg4: .DB  'M','H','z',0
  Messg5: .DB  ' ',' ',' ',' ','A','U','T','O','T','U','N','E',' ',' ',' ',' ', 0, 0
  Messg6: .DB  ' ',' ',' ',' ','P','R','E','S','E','T','S',' ',' ',' ',' ',' ', 0, 0

;====================================================================================
;******************************************************************************
	.include "I2C_hard_driver.asm"			;   I2C
	.include "HD44780_driver.asm" 			; LCD
	.include "User_set.asm"					; 
;******************************************************************************

	.EXIT
